# Copyright (C) 2020 ASTRON (Netherlands Institute for Radio Astronomy)
# SPDX-License-Identifier: GPL-3.0-or-later

project(cpu-reference)

# sources and header files
set(${PROJECT_NAME}_headers Reference.h ReferenceC.h)

set(${PROJECT_NAME}_sources Reference.cpp ReferenceC.cpp ReferenceKernels.cpp)

# create library
add_library(${PROJECT_NAME} OBJECT ${${PROJECT_NAME}_headers}
                                   ${${PROJECT_NAME}_sources})
target_link_libraries(${PROJECT_NAME} PRIVATE xtensor)

if(BUILD_WITH_MKL)
  target_include_directories(${PROJECT_NAME} PRIVATE ${MKL_INCLUDE_DIRS})
else()
  target_link_libraries(${PROJECT_NAME} PRIVATE PkgConfig::FFTW)
endif()

# Copy header files
install(FILES ${${PROJECT_NAME}_headers} DESTINATION include/CPU/Reference)

# Add kernels
add_subdirectory(kernels)
